//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 176:  SwitchLabel ::= case ConstantExpression :
 *</b>
 */
public class CaseLabel extends Ast implements ISwitchLabel
{
    private IConstantExpression _ConstantExpression;

    public IConstantExpression getConstantExpression() { return _ConstantExpression; }

    public CaseLabel(IToken leftIToken, IToken rightIToken,
                     IConstantExpression _ConstantExpression)
    {
        super(leftIToken, rightIToken);

        this._ConstantExpression = _ConstantExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof CaseLabel)) return false;
        CaseLabel other = (CaseLabel) o;
        if (! _ConstantExpression.equals(other.getConstantExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getConstantExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


