//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 66:  ClassBody ::= { ClassBodyDeclarationsopt }
 *</b>
 */
public class ClassBody extends Ast implements IClassBody
{
    private ClassBodyDeclarationList _ClassBodyDeclarationsopt;

    public ClassBodyDeclarationList getClassBodyDeclarationsopt() { return _ClassBodyDeclarationsopt; }

    public ClassBody(IToken leftIToken, IToken rightIToken,
                     ClassBodyDeclarationList _ClassBodyDeclarationsopt)
    {
        super(leftIToken, rightIToken);

        this._ClassBodyDeclarationsopt = _ClassBodyDeclarationsopt;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ClassBody)) return false;
        ClassBody other = (ClassBody) o;
        if (! _ClassBodyDeclarationsopt.equals(other.getClassBodyDeclarationsopt())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getClassBodyDeclarationsopt().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


