//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 222:  Dims ::= Dim
 *<li>Rule 223:  Dims ::= Dims Dim
 *<li>Rule 324:  Dimsopt ::= $Empty
 *<li>Rule 325:  Dimsopt ::= Dims
 *</b>
 */
public class DimList extends AstList implements IDims, IDimsopt
{
    public Dim getDimAt(int i) { return (Dim) getElementAt(i); }

    public DimList(IToken leftIToken, IToken rightIToken, boolean leftRecursive)
    {
        super(leftIToken, rightIToken, leftRecursive);
        initialize();
    }

    public DimList(Dim _Dim, boolean leftRecursive)
    {
        super((Ast) _Dim, leftRecursive);
        initialize();
    }

    public void add(Dim _Dim)
    {
        super.add((Ast) _Dim);
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        if (! (o instanceof DimList)) return false;
        DimList other = (DimList) o;
        if (size() != other.size()) return false;
        for (int i = 0; i < size(); i++)
        {
            Dim element = getDimAt(i);
            if (! element.equals(other.getDimAt(i))) return false;
        }
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        for (int i = 0; i < size(); i++)
            hash = hash * 31 + (getDimAt(i).hashCode());
        return hash;
    }

    public void accept(Visitor v) { for (int i = 0; i < size(); i++) v.visit(getDimAt(i)); }
    public void accept(ArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) v.visit(getDimAt(i), o); }
    public Object accept(ResultVisitor v) { for (int i = 0; i < size(); i++) v.visit(getDimAt(i)); return null; }
    public Object accept(ResultArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) v.visit(getDimAt(i), o); return null; }
}


