//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<em>
 *<li>Rule 276:  ExclusiveOrExpression ::= AndExpression
 *</em>
 *<p>
 *<b>
 *<li>Rule 277:  ExclusiveOrExpression ::= ExclusiveOrExpression ^ AndExpression
 *</b>
 */
public class ExclusiveOrExpression extends Ast implements IExclusiveOrExpression
{
    private IExclusiveOrExpression _ExclusiveOrExpression;
    private IAndExpression _AndExpression;

    public IExclusiveOrExpression getExclusiveOrExpression() { return _ExclusiveOrExpression; }
    public IAndExpression getAndExpression() { return _AndExpression; }

    public ExclusiveOrExpression(IToken leftIToken, IToken rightIToken,
                                 IExclusiveOrExpression _ExclusiveOrExpression,
                                 IAndExpression _AndExpression)
    {
        super(leftIToken, rightIToken);

        this._ExclusiveOrExpression = _ExclusiveOrExpression;
        this._AndExpression = _AndExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ExclusiveOrExpression)) return false;
        ExclusiveOrExpression other = (ExclusiveOrExpression) o;
        if (! _ExclusiveOrExpression.equals(other.getExclusiveOrExpression())) return false;
        if (! _AndExpression.equals(other.getAndExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getExclusiveOrExpression().hashCode());
        hash = hash * 31 + (getAndExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


