//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 157:  ExpressionStatement ::= StatementExpression ;
 *</b>
 */
public class ExpressionStatement extends Ast implements IExpressionStatement
{
    private IStatementExpression _StatementExpression;

    public IStatementExpression getStatementExpression() { return _StatementExpression; }

    public ExpressionStatement(IToken leftIToken, IToken rightIToken,
                               IStatementExpression _StatementExpression)
    {
        super(leftIToken, rightIToken);

        this._StatementExpression = _StatementExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ExpressionStatement)) return false;
        ExpressionStatement other = (ExpressionStatement) o;
        if (! _StatementExpression.equals(other.getStatementExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getStatementExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


