//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 225:  FieldAccess ::= Primary . IDENTIFIER
 *</b>
 */
public class FieldAccess extends Ast implements IFieldAccess
{
    private IPrimary _Primary;

    public IPrimary getPrimary() { return _Primary; }

    public FieldAccess(IToken leftIToken, IToken rightIToken,
                       IPrimary _Primary)
    {
        super(leftIToken, rightIToken);

        this._Primary = _Primary;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof FieldAccess)) return false;
        FieldAccess other = (FieldAccess) o;
        if (! _Primary.equals(other.getPrimary())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getPrimary().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


