//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 181:  ForStatement ::= for ( ForInitopt ; Expressionopt ; ForUpdateopt ) Statement
 *<li>Rule 182:  ForStatementNoShortIf ::= for ( ForInitopt ; Expressionopt ; ForUpdateopt ) StatementNoShortIf$Statement
 *</b>
 */
public class ForStatement extends Ast implements IForStatement, IForStatementNoShortIf
{
    private IForInitopt _ForInitopt;
    private IExpressionopt _Expressionopt;
    private StatementExpressionList _ForUpdateopt;
    private Ast _Statement;

    /**
     * The value returned by <b>getForInitopt</b> may be <b>null</b>
     */
    public IForInitopt getForInitopt() { return _ForInitopt; }
    /**
     * The value returned by <b>getExpressionopt</b> may be <b>null</b>
     */
    public IExpressionopt getExpressionopt() { return _Expressionopt; }
    public StatementExpressionList getForUpdateopt() { return _ForUpdateopt; }
    public Ast getStatement() { return _Statement; }

    public ForStatement(IToken leftIToken, IToken rightIToken,
                        IForInitopt _ForInitopt,
                        IExpressionopt _Expressionopt,
                        StatementExpressionList _ForUpdateopt,
                        Ast _Statement)
    {
        super(leftIToken, rightIToken);

        this._ForInitopt = _ForInitopt;
        this._Expressionopt = _Expressionopt;
        this._ForUpdateopt = _ForUpdateopt;
        this._Statement = _Statement;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof ForStatement)) return false;
        ForStatement other = (ForStatement) o;
        if (_ForInitopt == null && other.getForInitopt() != null) return false;
        else if (! _ForInitopt.equals(other.getForInitopt())) return false;
        if (_Expressionopt == null && other.getExpressionopt() != null) return false;
        else if (! _Expressionopt.equals(other.getExpressionopt())) return false;
        if (! _ForUpdateopt.equals(other.getForUpdateopt())) return false;
        if (! _Statement.equals(other.getStatement())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getForInitopt() == null ? 0 : getForInitopt().hashCode());
        hash = hash * 31 + (getExpressionopt() == null ? 0 : getExpressionopt().hashCode());
        hash = hash * 31 + (getForUpdateopt().hashCode());
        hash = hash * 31 + (getStatement().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


