//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 270:  RelationalExpression ::= RelationalExpression instanceof ReferenceType
 *</b>
 */
public class InstanceofExpression extends Ast implements IRelationalExpression
{
    private IRelationalExpression _RelationalExpression;
    private IReferenceType _ReferenceType;

    public IRelationalExpression getRelationalExpression() { return _RelationalExpression; }
    public IReferenceType getReferenceType() { return _ReferenceType; }

    public InstanceofExpression(IToken leftIToken, IToken rightIToken,
                                IRelationalExpression _RelationalExpression,
                                IReferenceType _ReferenceType)
    {
        super(leftIToken, rightIToken);

        this._RelationalExpression = _RelationalExpression;
        this._ReferenceType = _ReferenceType;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof InstanceofExpression)) return false;
        InstanceofExpression other = (InstanceofExpression) o;
        if (! _RelationalExpression.equals(other.getRelationalExpression())) return false;
        if (! _ReferenceType.equals(other.getReferenceType())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getRelationalExpression().hashCode());
        hash = hash * 31 + (getReferenceType().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


