//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 228:  MethodInvocation ::= Name ( ArgumentListopt )
 *</b>
 */
public class MethodInvocation extends Ast implements IMethodInvocation
{
    private IName _Name;
    private ExpressionList _ArgumentListopt;

    public IName getName() { return _Name; }
    public ExpressionList getArgumentListopt() { return _ArgumentListopt; }

    public MethodInvocation(IToken leftIToken, IToken rightIToken,
                            IName _Name,
                            ExpressionList _ArgumentListopt)
    {
        super(leftIToken, rightIToken);

        this._Name = _Name;
        this._ArgumentListopt = _ArgumentListopt;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof MethodInvocation)) return false;
        MethodInvocation other = (MethodInvocation) o;
        if (! _Name.equals(other.getName())) return false;
        if (! _ArgumentListopt.equals(other.getArgumentListopt())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getName().hashCode());
        hash = hash * 31 + (getArgumentListopt().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


