//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 209:  PrimaryNoNewArray ::= Type . class
 *</b>
 */
public class PrimaryClassLiteral extends Ast implements IPrimaryNoNewArray
{
    private IType _Type;

    public IType getType() { return _Type; }

    public PrimaryClassLiteral(IToken leftIToken, IToken rightIToken,
                               IType _Type)
    {
        super(leftIToken, rightIToken);

        this._Type = _Type;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof PrimaryClassLiteral)) return false;
        PrimaryClassLiteral other = (PrimaryClassLiteral) o;
        if (! _Type.equals(other.getType())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getType().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


