//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 210:  PrimaryNoNewArray ::= void . class
 *</b>
 */
public class PrimaryVoidClassLiteral extends Ast implements IPrimaryNoNewArray
{
    public PrimaryVoidClassLiteral(IToken leftIToken, IToken rightIToken)
    {
        super(leftIToken, rightIToken);

        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof PrimaryVoidClassLiteral)) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


