//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 27:  ArrayType ::= PrimitiveType Dims
 *</b>
 */
public class PrimitiveArrayType extends Ast implements IArrayType
{
    private IPrimitiveType _PrimitiveType;
    private DimList _Dims;

    public IPrimitiveType getPrimitiveType() { return _PrimitiveType; }
    public DimList getDims() { return _Dims; }

    public PrimitiveArrayType(IToken leftIToken, IToken rightIToken,
                              IPrimitiveType _PrimitiveType,
                              DimList _Dims)
    {
        super(leftIToken, rightIToken);

        this._PrimitiveType = _PrimitiveType;
        this._Dims = _Dims;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof PrimitiveArrayType)) return false;
        PrimitiveArrayType other = (PrimitiveArrayType) o;
        if (! _PrimitiveType.equals(other.getPrimitiveType())) return false;
        if (! _Dims.equals(other.getDims())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getPrimitiveType().hashCode());
        hash = hash * 31 + (getDims().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


