//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

public interface ResultVisitor
{
    Object visit(AstToken n);
    Object visit(IntegerLiteral n);
    Object visit(LongLiteral n);
    Object visit(FloatLiteral n);
    Object visit(DoubleLiteral n);
    Object visit(BooleanLiteral n);
    Object visit(CharacterLiteral n);
    Object visit(StringLiteral n);
    Object visit(NullLiteral n);
    Object visit(TrueLiteral n);
    Object visit(FalseLiteral n);
    Object visit(BooleanType n);
    Object visit(ByteType n);
    Object visit(ShortType n);
    Object visit(IntType n);
    Object visit(LongType n);
    Object visit(CharType n);
    Object visit(FloatType n);
    Object visit(DoubleType n);
    Object visit(PrimitiveArrayType n);
    Object visit(ClassOrInterfaceArrayType n);
    Object visit(SimpleName n);
    Object visit(QualifiedName n);
    Object visit(CompilationUnit n);
    Object visit(ImportDeclarationList n);
    Object visit(TypeDeclarationList n);
    Object visit(PackageDeclaration n);
    Object visit(SingleTypeImportDeclaration n);
    Object visit(TypeImportOnDemandDeclaration n);
    Object visit(EmptyDeclaration n);
    Object visit(ModifierList n);
    Object visit(PublicModifier n);
    Object visit(ProtectedModifier n);
    Object visit(PrivateModifier n);
    Object visit(StaticModifier n);
    Object visit(AbstractModifier n);
    Object visit(FinalModifier n);
    Object visit(NativeModifier n);
    Object visit(StrictfpModifier n);
    Object visit(SynchronizedModifier n);
    Object visit(TransientModifier n);
    Object visit(VolatileModifier n);
    Object visit(ClassDeclaration n);
    Object visit(Super n);
    Object visit(InterfaceTypeList n);
    Object visit(ClassBody n);
    Object visit(ClassBodyDeclarationList n);
    Object visit(FieldDeclaration n);
    Object visit(VariableDeclaratorList n);
    Object visit(VariableDeclarator n);
    Object visit(VariableDeclaratorId n);
    Object visit(MethodDeclaration n);
    Object visit(TypedMethodHeader n);
    Object visit(VoidMethodHeader n);
    Object visit(MethodDeclarator n);
    Object visit(FormalParameterList n);
    Object visit(FormalParameter n);
    Object visit(ClassTypeList n);
    Object visit(EmptyMethodBody n);
    Object visit(StaticInitializer n);
    Object visit(ConstructorDeclaration n);
    Object visit(ConstructorDeclarator n);
    Object visit(ConstructorBody n);
    Object visit(ThisCall n);
    Object visit(SuperCall n);
    Object visit(InterfaceDeclaration n);
    Object visit(InterfaceBody n);
    Object visit(InterfaceMemberDeclarationList n);
    Object visit(AbstractMethodDeclaration n);
    Object visit(ArrayInitializer n);
    Object visit(VariableInitializerList n);
    Object visit(Block n);
    Object visit(BlockStatementList n);
    Object visit(LocalVariableDeclarationStatement n);
    Object visit(LocalVariableDeclaration n);
    Object visit(EmptyStatement n);
    Object visit(LabeledStatement n);
    Object visit(ExpressionStatement n);
    Object visit(IfStatement n);
    Object visit(SwitchStatement n);
    Object visit(SwitchBlock n);
    Object visit(SwitchBlockStatementList n);
    Object visit(SwitchBlockStatement n);
    Object visit(SwitchLabelList n);
    Object visit(CaseLabel n);
    Object visit(DefaultLabel n);
    Object visit(WhileStatement n);
    Object visit(DoStatement n);
    Object visit(ForStatement n);
    Object visit(StatementExpressionList n);
    Object visit(BreakStatement n);
    Object visit(ContinueStatement n);
    Object visit(ReturnStatement n);
    Object visit(ThrowStatement n);
    Object visit(SynchronizedStatement n);
    Object visit(TryStatement n);
    Object visit(CatchClauseList n);
    Object visit(CatchClause n);
    Object visit(Finally n);
    Object visit(ParenthesizedExpression n);
    Object visit(PrimaryThis n);
    Object visit(PrimaryClassLiteral n);
    Object visit(PrimaryVoidClassLiteral n);
    Object visit(ClassInstanceCreationExpression n);
    Object visit(ExpressionList n);
    Object visit(ArrayCreationExpression n);
    Object visit(DimExprList n);
    Object visit(DimExpr n);
    Object visit(DimList n);
    Object visit(Dim n);
    Object visit(FieldAccess n);
    Object visit(SuperFieldAccess n);
    Object visit(MethodInvocation n);
    Object visit(PrimaryMethodInvocation n);
    Object visit(SuperMethodInvocation n);
    Object visit(ArrayAccess n);
    Object visit(PostIncrementExpression n);
    Object visit(PostDecrementExpression n);
    Object visit(PlusUnaryExpression n);
    Object visit(MinusUnaryExpression n);
    Object visit(PreIncrementExpression n);
    Object visit(PreDecrementExpression n);
    Object visit(UnaryComplementExpression n);
    Object visit(UnaryNotExpression n);
    Object visit(PrimitiveCastExpression n);
    Object visit(ClassCastExpression n);
    Object visit(MultiplyExpression n);
    Object visit(DivideExpression n);
    Object visit(ModExpression n);
    Object visit(AddExpression n);
    Object visit(SubtractExpression n);
    Object visit(LeftShiftExpression n);
    Object visit(RightShiftExpression n);
    Object visit(UnsignedRightShiftExpression n);
    Object visit(LessExpression n);
    Object visit(GreaterExpression n);
    Object visit(LessEqualExpression n);
    Object visit(GreaterEqualExpression n);
    Object visit(InstanceofExpression n);
    Object visit(EqualExpression n);
    Object visit(NotEqualExpression n);
    Object visit(AndExpression n);
    Object visit(ExclusiveOrExpression n);
    Object visit(InclusiveOrExpression n);
    Object visit(ConditionalAndExpression n);
    Object visit(ConditionalOrExpression n);
    Object visit(ConditionalExpression n);
    Object visit(Assignment n);
    Object visit(EqualOperator n);
    Object visit(MultiplyEqualOperator n);
    Object visit(DivideEqualOperator n);
    Object visit(ModEqualOperator n);
    Object visit(PlusEqualOperator n);
    Object visit(MinusEqualOperator n);
    Object visit(LeftShiftEqualOperator n);
    Object visit(RightShiftEqualOperator n);
    Object visit(UnsignedRightShiftEqualOperator n);
    Object visit(AndEqualOperator n);
    Object visit(ExclusiveOrEqualOperator n);
    Object visit(OrEqualOperator n);
    Object visit(Commaopt n);
    Object visit(IDENTIFIERopt n);
}

