//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 264:  ShiftExpression ::= ShiftExpression >>> AdditiveExpression
 *</b>
 */
public class UnsignedRightShiftExpression extends Ast implements IShiftExpression
{
    private IShiftExpression _ShiftExpression;
    private IAdditiveExpression _AdditiveExpression;

    public IShiftExpression getShiftExpression() { return _ShiftExpression; }
    public IAdditiveExpression getAdditiveExpression() { return _AdditiveExpression; }

    public UnsignedRightShiftExpression(IToken leftIToken, IToken rightIToken,
                                        IShiftExpression _ShiftExpression,
                                        IAdditiveExpression _AdditiveExpression)
    {
        super(leftIToken, rightIToken);

        this._ShiftExpression = _ShiftExpression;
        this._AdditiveExpression = _AdditiveExpression;
        initialize();
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        //
        // The supers call is not required for now because Ast nodes
        // can only extend the root Ast, AstToken and AstList and none
        // of these nodes contain children.
        //
        // if (! super.equals(o)) return false;
        //
        if (! (o instanceof UnsignedRightShiftExpression)) return false;
        UnsignedRightShiftExpression other = (UnsignedRightShiftExpression) o;
        if (! _ShiftExpression.equals(other.getShiftExpression())) return false;
        if (! _AdditiveExpression.equals(other.getAdditiveExpression())) return false;
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        hash = hash * 31 + (getShiftExpression().hashCode());
        hash = hash * 31 + (getAdditiveExpression().hashCode());
        return hash;
    }

    public void accept(Visitor v) { v.visit(this); }
    public void accept(ArgumentVisitor v, Object o) { v.visit(this, o); }
    public Object accept(ResultVisitor v) { return v.visit(this); }
    public Object accept(ResultArgumentVisitor v, Object o) { return v.visit(this, o); }
}


