//
// A copyright notice must contain a "C" enclosed in parentheses: (C) 
//

package expandedjavaparser.Ast;

import lpg.lpgjavaruntime.*;

/**
 *<b>
 *<li>Rule 79:  VariableDeclarators ::= VariableDeclarator
 *<li>Rule 80:  VariableDeclarators ::= VariableDeclarators , VariableDeclarator
 *</b>
 */
public class VariableDeclaratorList extends AstList implements IVariableDeclarators
{
    public IVariableDeclarator getVariableDeclaratorAt(int i) { return (IVariableDeclarator) getElementAt(i); }

    public VariableDeclaratorList(IToken leftIToken, IToken rightIToken, boolean leftRecursive)
    {
        super(leftIToken, rightIToken, leftRecursive);
        initialize();
    }

    public VariableDeclaratorList(IVariableDeclarator _VariableDeclarator, boolean leftRecursive)
    {
        super((Ast) _VariableDeclarator, leftRecursive);
        initialize();
    }

    public void add(IVariableDeclarator _VariableDeclarator)
    {
        super.add((Ast) _VariableDeclarator);
    }

    public boolean equals(Object o)
    {
        if (o == this) return true;
        if (! (o instanceof VariableDeclaratorList)) return false;
        VariableDeclaratorList other = (VariableDeclaratorList) o;
        if (size() != other.size()) return false;
        for (int i = 0; i < size(); i++)
        {
            IVariableDeclarator element = getVariableDeclaratorAt(i);
            if (! element.equals(other.getVariableDeclaratorAt(i))) return false;
        }
        return true;
    }

    public int hashCode()
    {
        int hash = 7;
        for (int i = 0; i < size(); i++)
            hash = hash * 31 + (getVariableDeclaratorAt(i).hashCode());
        return hash;
    }

    public void accept(Visitor v) { for (int i = 0; i < size(); i++) getVariableDeclaratorAt(i).accept(v); }
    public void accept(ArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) getVariableDeclaratorAt(i).accept(v, o); }
    public Object accept(ResultVisitor v) { for (int i = 0; i < size(); i++) getVariableDeclaratorAt(i).accept(v); return null; }
    public Object accept(ResultArgumentVisitor v, Object o) { for (int i = 0; i < size(); i++) getVariableDeclaratorAt(i).accept(v, o); return null; }
}


