//
// This is the grammar specification from the Final Draft of the generic spec.
//
package genericjavaparser;

public interface JavaParsersym {
    public final static int
      TK_IntegerLiteral = 33,
      TK_LongLiteral = 34,
      TK_FloatingPointLiteral = 35,
      TK_DoubleLiteral = 36,
      TK_CharacterLiteral = 37,
      TK_StringLiteral = 38,
      TK_MINUS_MINUS = 29,
      TK_OR = 87,
      TK_MINUS = 47,
      TK_MINUS_EQUAL = 74,
      TK_NOT = 50,
      TK_NOT_EQUAL = 88,
      TK_REMAINDER = 89,
      TK_REMAINDER_EQUAL = 75,
      TK_AND = 71,
      TK_AND_AND = 90,
      TK_AND_EQUAL = 76,
      TK_LPAREN = 3,
      TK_RPAREN = 20,
      TK_MULTIPLY = 72,
      TK_MULTIPLY_EQUAL = 77,
      TK_COMMA = 45,
      TK_DOT = 43,
      TK_DIVIDE = 91,
      TK_DIVIDE_EQUAL = 78,
      TK_COLON = 52,
      TK_SEMICOLON = 4,
      TK_QUESTION = 92,
      TK_AT = 1,
      TK_LBRACKET = 25,
      TK_RBRACKET = 55,
      TK_XOR = 93,
      TK_XOR_EQUAL = 79,
      TK_LBRACE = 30,
      TK_OR_OR = 97,
      TK_OR_EQUAL = 80,
      TK_RBRACE = 44,
      TK_TWIDDLE = 51,
      TK_PLUS = 48,
      TK_PLUS_PLUS = 31,
      TK_PLUS_EQUAL = 81,
      TK_LESS = 23,
      TK_LEFT_SHIFT = 73,
      TK_LEFT_SHIFT_EQUAL = 82,
      TK_LESS_EQUAL = 83,
      TK_EQUAL = 53,
      TK_EQUAL_EQUAL = 94,
      TK_GREATER = 46,
      TK_GREATER_EQUAL = 105,
      TK_RIGHT_SHIFT = 106,
      TK_RIGHT_SHIFT_EQUAL = 107,
      TK_UNSIGNED_RIGHT_SHIFT = 108,
      TK_UNSIGNED_RIGHT_SHIFT_EQUAL = 109,
      TK_ELLIPSIS = 98,
      TK_abstract = 17,
      TK_assert = 59,
      TK_boolean = 5,
      TK_break = 60,
      TK_byte = 6,
      TK_case = 70,
      TK_catch = 99,
      TK_char = 7,
      TK_class = 24,
      TK_const = 110,
      TK_continue = 61,
      TK_default = 62,
      TK_do = 63,
      TK_double = 8,
      TK_enum = 26,
      TK_else = 95,
      TK_extends = 84,
      TK_false = 39,
      TK_final = 19,
      TK_finally = 100,
      TK_float = 9,
      TK_for = 64,
      TK_goto = 111,
      TK_if = 65,
      TK_implements = 104,
      TK_import = 101,
      TK_instanceof = 85,
      TK_int = 10,
      TK_interface = 22,
      TK_long = 11,
      TK_native = 86,
      TK_new = 28,
      TK_null = 40,
      TK_package = 102,
      TK_private = 14,
      TK_protected = 15,
      TK_public = 12,
      TK_return = 66,
      TK_short = 13,
      TK_static = 16,
      TK_strictfp = 18,
      TK_super = 27,
      TK_switch = 67,
      TK_synchronized = 54,
      TK_this = 32,
      TK_throw = 68,
      TK_throws = 103,
      TK_transient = 56,
      TK_true = 41,
      TK_try = 69,
      TK_void = 21,
      TK_volatile = 57,
      TK_while = 58,
      TK_EOF_TOKEN = 96,
      TK_IDENTIFIER = 2,
      TK_ERROR_TOKEN = 49,
      TK_name = 42;

      public final static String orderedTerminalSymbols[] = {
                 "",
                 "AT",
                 "IDENTIFIER",
                 "LPAREN",
                 "SEMICOLON",
                 "boolean",
                 "byte",
                 "char",
                 "double",
                 "float",
                 "int",
                 "long",
                 "public",
                 "short",
                 "private",
                 "protected",
                 "static",
                 "abstract",
                 "strictfp",
                 "final",
                 "RPAREN",
                 "void",
                 "interface",
                 "LESS",
                 "class",
                 "LBRACKET",
                 "enum",
                 "super",
                 "new",
                 "MINUS_MINUS",
                 "LBRACE",
                 "PLUS_PLUS",
                 "this",
                 "IntegerLiteral",
                 "LongLiteral",
                 "FloatingPointLiteral",
                 "DoubleLiteral",
                 "CharacterLiteral",
                 "StringLiteral",
                 "false",
                 "null",
                 "true",
                 "name",
                 "DOT",
                 "RBRACE",
                 "COMMA",
                 "GREATER",
                 "MINUS",
                 "PLUS",
                 "ERROR_TOKEN",
                 "NOT",
                 "TWIDDLE",
                 "COLON",
                 "EQUAL",
                 "synchronized",
                 "RBRACKET",
                 "transient",
                 "volatile",
                 "while",
                 "assert",
                 "break",
                 "continue",
                 "default",
                 "do",
                 "for",
                 "if",
                 "return",
                 "switch",
                 "throw",
                 "try",
                 "case",
                 "AND",
                 "MULTIPLY",
                 "LEFT_SHIFT",
                 "MINUS_EQUAL",
                 "REMAINDER_EQUAL",
                 "AND_EQUAL",
                 "MULTIPLY_EQUAL",
                 "DIVIDE_EQUAL",
                 "XOR_EQUAL",
                 "OR_EQUAL",
                 "PLUS_EQUAL",
                 "LEFT_SHIFT_EQUAL",
                 "LESS_EQUAL",
                 "extends",
                 "instanceof",
                 "native",
                 "OR",
                 "NOT_EQUAL",
                 "REMAINDER",
                 "AND_AND",
                 "DIVIDE",
                 "QUESTION",
                 "XOR",
                 "EQUAL_EQUAL",
                 "else",
                 "EOF_TOKEN",
                 "OR_OR",
                 "ELLIPSIS",
                 "catch",
                 "finally",
                 "import",
                 "package",
                 "throws",
                 "implements",
                 "GREATER_EQUAL",
                 "RIGHT_SHIFT",
                 "RIGHT_SHIFT_EQUAL",
                 "UNSIGNED_RIGHT_SHIFT",
                 "UNSIGNED_RIGHT_SHIFT_EQUAL",
                 "const",
                 "goto"
             };

    public final static boolean isValidForParser = true;
}
