#ifndef jikespg_prs_INCLUDED
#define jikespg_prs_INCLUDED

#include "jikespg_def.h"
#include "jikespg_sym.h"

#include <stdio.h> // Need definition for NULL

#include "LexStream.h"

class jikespg_prs_table
{
public:
    static inline int original_state(int state) { return -base_check[state]; }
    static inline int asi(int state) { return asb[original_state(state)]; }
    static inline int nasi(int state) { return nasb[original_state(state)]; }
    static inline int in_symbol(int state) { return in_symb[original_state(state)]; }

    static const signed char base_check[];
    static const signed char *rhs;
    static const unsigned short base_action[];
    static const unsigned short *lhs;
    static const unsigned char term_check[];
    static const unsigned short term_action[];
    static const unsigned short asb[];
    static const unsigned char asr[];
    static const unsigned short nasb[];
    static const unsigned short nasr[];
    static const unsigned char terminal_index[];
    static const unsigned char non_terminal_index[];
    static const unsigned char scope_prefix[];
    static const unsigned char scope_suffix[];
    static const unsigned char scope_lhs[];
    static const unsigned char scope_la[];
    static const unsigned char scope_state_set[];
    static const unsigned char scope_rhs[];
    static const unsigned char scope_state[];
    static const unsigned char in_symb[];
    static const unsigned short name_start[];
    static const char string_buffer[];

    static inline int nt_action(int state, int sym)
    {
        return base_action[state + sym];
    }

    static inline int t_action(int act, int sym, LexStream *stream)
    {
        act = base_action[act];
        int i = act + sym;

        act = term_action[term_check[i] == sym ? i : act];

        if (act > LA_STATE_OFFSET)
        {
            for (TokenObject tok = stream -> Peek();
                 ;
                 tok = stream -> Next(tok))
            {
               act -= LA_STATE_OFFSET;
               sym = stream -> Kind(tok);
               i = act + sym;
               act = term_action[term_check[i] == sym ? i : act];
               if (act <= LA_STATE_OFFSET)
                   break;
            } 
        }

        return act;
    }
};

#endif /* jikespg_prs_INCLUDED */
