// XMOS
package org.eclipse.cdt.debug.mi.core.command;

import org.eclipse.cdt.debug.mi.core.MIException;
import org.eclipse.cdt.debug.mi.core.output.MIInfo;
import org.eclipse.cdt.debug.mi.core.output.MIOutput;
import org.eclipse.cdt.debug.mi.core.output.MISymbolListVariablesInfo;

/**
 * 
 *     -symbol-list-variables PRINT-VALUES
 *
 * Display the global variable names for the current tile. With an
 * argument of 0 prints only the names of the variables, with argument of 1
 * prints also their values.
 * 
 */
public class MISymbolListVariables extends MICommand 
{
    public MISymbolListVariables(String miVersion, boolean printValues) {
        super(miVersion, "-symbol-list-variables"); //$NON-NLS-1$
        if (printValues) {
            setParameters(new String[]{"1"}); //$NON-NLS-1$
        } else {
            setParameters(new String[]{"0"}); //$NON-NLS-1$
        }
    }

    public MISymbolListVariablesInfo getMISymbolListVariablesInfo() throws MIException {
        return (MISymbolListVariablesInfo)getMIInfo();
    }

    public MIInfo getMIInfo() throws MIException {
        MIInfo info = null;
        MIOutput out = getMIOutput();
        if (out != null) {
            info = new MISymbolListVariablesInfo(out);
            if (info.isError()) {
                throwMIException(info, out);
            }
        }
        return info;
    }
}
