package org.eclipse.ui;

import org.eclipse.core.resources.IProject;
import org.eclipse.swt.widgets.Display;

// XMOS - Used for the 'current project' mechanism.
public class CurrentProjectHandler {

    private static IProject m_currentProject; 

    public static void setCurrentProject(IProject project) {
        m_currentProject = project;
        
        // Ensures that the (bold status) decorator gets refreshed due to the above change. 
        Display.getDefault().syncExec(new Runnable() {
            public void run() {
                IDecoratorManager manager = PlatformUI.getWorkbench().getDecoratorManager();
                manager.update("com.xmos.cdt.ui.decorators.CurrentProject"); //$NON-NLS-1$
            }
        });
    }
    
    public static IProject getCurrentProject() {
        return m_currentProject;
    }   
}
